;;=============================================================================
;;
;;     ,   AT  PS/2 -  
;;
;;==========================================================================
;;  ,        
;;       
;;

.equ	debug_CallPort	= PIND
.equ	debug_CallPin	= 1

.def	debug_rState	= r2		;     D0        ţ   D2..D1


;
;  Raw- 
;   F1-F4      
;    CallPin  ""
;
Debug_Init:
 sbic	debug_CallPort, debug_CallPin
 ret

 clr	debug_rState

;   PS/2 

 rcall	pkg_LockClock

;     

 rcall	akb_ShortInit

 rcall	Wait_300ms			; ,   
 rcall	akb_Print
.db	"PS/2 <-> AGAT CONVERTER       ",1
 rcall	akb_CR
 rcall	akb_Print
.db	"VERSION 0.98 PRE BETA FRAM    ",1
 rcall	akb_CR
 rcall	akb_Print
.db	"          2017 (C) AGATCOMP.RU",1
 rcall	akb_CR

;      PS/2         
;   ,   

Debug_Loop:

; ģ   PS/2 

 rcall	pkb_RecvByte
 mov	r17, r16
 brcs	debug_RecvErr

;   

 ldi	r16, '+'
 rcall	akb_SendByte_WithCtrl
 rcall	Wait_CharPause
 mov	r16, r17
 rcall	akb_SendHex

;     -     

 sbrs	debug_rState, 0		;    ,    -      
 rjmp	Debug_Kbd
 
 ldi	r16, 2			;  ޣ 
 add	debug_rState, r16
 mov	r16, debug_rState
 cpi	r16, 7
 brne	Debug_Loop
 
 ldi	r16, 1			;      -  
 mov	debug_rState, r16
 rcall	akb_CR
 rjmp	Debug_Loop

Debug_Kbd:

;     0xAA, 0x00 -      
;         Σ

 tst	r17
 breq	Debug_Mouse

;      

 cpi	r17, 0xE0
 breq	Debug_Loop
 cpi	r17, 0xE1
 breq	Debug_Loop
 cpi	r17, 0xF0
 breq	Debug_Loop

 rcall	akb_CR

 sbrc	debug_rState, 0
 rjmp	Debug_Loop

;    ,    

 cpi	r17, 0x05
 breq	Debug_F1
 
 cpi	r17, 0x06
 breq	Debug_F2
 
 cpi	r17, 0x04
 breq	Debug_F3

 cpi	r17, 0x0C
 breq	Debug_F4

 rjmp	Debug_Loop

;  ɣ 

debug_RecvErr:

;      
 mov	r16, debug_rState
 andi	r16, 1
 mov	debug_rState, r16

;    
 rcall	Debug_PrintError
 rjmp	Debug_Loop

;  
Debug_Mouse:
 ldi	r16, 0xF4
 rcall	Debug_SendByte_PS
 ldi	r16, 0x01
 mov	debug_rState, r16
 rjmp	Debug_Loop


;
;    
;

;      (    )
Debug_F4:
 ret

;  NumLock & ScroolLock
Debug_F3:
 ldi	r16, 0xED
 rcall	Debug_SendByte_PS
 rcall	Debug_RecvByte_PS
 ldi	r16, pkb_NumLed | pkb_ScroolLed
 rcall	Debug_SendByte_PS
 rcall	Debug_RecvByte_PS
 rjmp	Debug_Loop

;  Caps Lock
Debug_F2:
 ldi	r16, 0xED
 rcall	Debug_SendByte_PS
 rcall	Debug_RecvByte_PS
 ldi	r16, pkb_CapsLed
 rcall	Debug_SendByte_PS
 rcall	Debug_RecvByte_PS
 rjmp	Debug_Loop

; 
Debug_F1:
 ldi	r16, 0xFF
 rcall	Debug_SendByte_PS
 rjmp	Debug_Loop

;
;        
;
Debug_SendByte_PS:
 push	r16
 ldi	r16, '<'
 rcall	akb_SendByte_WithCtrl
 rcall	Wait_CharPause
 pop	r16
 push	r16
 rcall	akb_SendHex
 pop	r16
;
 rcall	pkb_SendByte
 brcs	Debug_PrintError
 ldi	r16, '+'
 rcall	akb_SendByte_WithCtrl
 rcall	Wait_CharPause
 rjmp	akb_CR

;
;      
;
Debug_RecvByte_PS:
 ldi	r16, '>'
 rcall	akb_SendByte_WithCtrl
 rcall	Wait_CharPause

; ģ 

 rcall	pkb_RecvByte
 mov	r17, r16
 brcs	Debug_PrintError

;   

 ldi	r16, '+'
 rcall	akb_SendByte_WithCtrl
 rcall	Wait_CharPause
 rjmp	Debug_PrintHex

;
;   
;    r17
;
Debug_PrintError:
 ldi	r16, '-'
 rcall	akb_SendByte_WithCtrl
 rcall	Wait_CharPause
 cpi	r17, 1
 breq	debug_PE_1
 cpi	r17, 2
 breq	debug_PE_2
 cpi	r17, 3
 breq	debug_PE_3
Debug_PrintHex:
 mov	r16, r17
 rcall	akb_SendHex
 rjmp	debug_PE_fin

debug_PE_1:
 rcall	akb_Print
.db	"TIMEOUT DURING RECEPTION",1
 rcall	Wait_300ms
 rjmp	debug_PE_fin

debug_PE_2:
 rcall	akb_Print
.db	"NO SYNC",1
 rjmp	debug_PE_fin

debug_PE_3:
 rcall	akb_Print
.db	"PARITY ERROR",1
 rcall	Wait_300ms
 rjmp	debug_PE_fin

debug_PE_fin:
 rjmp	akb_CR
