;;=============================================================================
;;
;;     ,   AT  PS/2 -  
;;
;;==========================================================================
;;   ,     "     ".
;;
;;         ,
;;   -,  ,  /LAT    ,   .
;;
;;        PS/2- ,
;;    -     .
;;

;
;     
;      ,      
;       ( Shift/Ctrl/Alt/Win)
;
;      r24/r25,  T = 0    , T = 1 -  
;
proc_IntKeyRouter:
 ldi	ZL, low (proc_IKR*2)
 ldi	ZH, high(proc_IKR*2)

proc_IKR_loop:
 lpm	XL, Z+			;   
 lpm	XH, Z+
 adiw	X, 0
 breq	proc_IKR_Match
;
 cp	XL, r24			;    
 brne	proc_IKR_next
 cp	XH, r25
 brne	proc_IKR_next
;
proc_IKR_Match:
 lpm	r16, Z+			;        (  )
 lpm	r17, Z+
 mov	ZL, r16
 mov	ZH, r17
 ijmp

proc_IKR_next:			;    
 adiw	Z, 2
 rjmp	proc_IKR_loop

; .dw -   (PS/2)
; .dw - -
proc_IKR:
.dw	0x0012		; RShift+RCtrl
.dw	proc_SetRUS
.dw	0x0014
.dw	proc_SetRUS

.dw	0x0077		; NumLock
.dw	proc_ChgRL

.dw	0x0059		; LShift+LCtrl
.dw	proc_SetLAT
.dw	0xE014
.dw	proc_SetLAT

.dw	0x007E		; ScroolLock
.dw	proc_ChgRL

.dw	0x0078		; F11
.dw	proc_Reset

.dw	0x0004		; F3
.dw	proc_ChgCharSet

.dw	0x000C		; F4
.dw	proc_ChgRepeatMode

.dw	0x0003		; F5
.dw	proc_PlayMacro

.dw	0x000B		; F6
.dw	proc_CaptMacro

.dw	0x0083		; F7
.dw	proc_FixMacro7

.dw	0x000A		; F8
.dw	proc_ChgRLSyncMode

.dw	0x0001		; F9
.dw	proc_FixMacro9

.dw	0
.dw	proc_AnyKey

;
;    ,     (T = 1)
;
proc_PressOnly:
 brtc	proc_PO_ret
 pop	r16
 pop	r17
proc_PO_ret:
proc_AnyKey:
 ret

;
; - .    
;

; 
; LShift+LCtrl -   -mode
proc_SetRUS:
 mov	r16, akb_rMod			;   
 andi	r16, (1<<akb_Mod_Shift) | (1<<akb_Mod_Ctrl) | (1<<akb_Mod_RL)
 cpi	r16, (1<<akb_Mod_Shift) | (1<<akb_Mod_Ctrl) | (1<<akb_Mod_RL)
 brne	proc_PO_ret			;         (  ?)

; ldi	r16, 0xFF - (1<<akb_Mod_RL)	;  ӣ ԣ -  ...
; and	akb_rMod, r16
; rjmp	pkb_ShowStatus			; ...   
 rjmp	proc_ChgRL

;
; RShift+RShift -   LAT-mode
proc_SetLAT:
 mov	r16, akb_rMod			;   
 andi	r16, (1<<akb_Mod_Shift) | (1<<akb_Mod_Ctrl) | (1<<akb_Mod_RL)
 cpi	r16, (1<<akb_Mod_Shift) | (1<<akb_Mod_Ctrl)
 brne	proc_PO_ret

; ldi	r16, 1<<akb_Mod_RL		;  ӣ ԣ -  ...
; or	akb_rMod, r16
; rjmp	pkb_ShowStatus			; ...   

;
;  RUS/LAT
proc_ChgRL:
 rcall	proc_PressOnly			;    -      
 ldi	r16, 1<<akb_Mod_RL		;   /LAT
 sbrc	main_rFlagsROM, main_FROM_RL_sync
 ori	r16, 1<<akb_Mod_Set		;    -   
 eor	akb_rMod, r16

proc_SyncRL_ShowStatus:
 sbi	akb_RusLatPort, akb_RusLatPin	;   /LAT
 sbrs	akb_rMod, akb_Mod_RL
 cbi	akb_RusLatPort, akb_RusLatPin

 rjmp	pkb_ShowStatus

;
; Scrool     Ctrl-Shift  ,  -  -
;proc_Scrool:
; mov	r16, akb_rMod			;   
; andi	r16, (1<<akb_Mod_Shift) | (1<<akb_Mod_Ctrl)
; cpi	r16, (1<<akb_Mod_Shift) | (1<<akb_Mod_Ctrl)
; brne	proc_ChgRL			;   

;
;    -
proc_Reset:
 mov	r16, akb_rMod			;    Ctrl
 andi	r16, 1<<akb_Mod_Ctrl
 cpi	r16, 1<<akb_Mod_Ctrl
 brne	proc_RESET_ret

 brts	proc_RESET_Pop
 sbi	akb_ResetPort, akb_ResetPin	;  -
 ret

proc_RESET_Pop:
 cbi	akb_ResetPort, akb_ResetPin	;  -

proc_RESET_ret:
 ret

;
;  
proc_ChgCharSet:
 rcall	proc_PressOnly
 ldi	r16, 1<<akb_Mod_Set
 sbrc	main_rFlagsROM, main_FROM_RL_sync
 ori	r16, 1<<akb_Mod_RL		;   /LAT,   
 eor	akb_rMod, r16
 rjmp	proc_SyncRL_ShowStatus

;
;    "" / "PC"
proc_ChgRepeatMode:
 rcall	proc_PressOnly
 ldi	r16, 1<<main_FROM_RepMode
 eor	main_rFlagsROM, r16
 rjmp	fl_Write_Sets

;
;    /L  
proc_ChgRLSyncMode:
 rcall	proc_PressOnly
 ldi	r16, 1<<main_FROM_RL_sync
 eor	main_rFlagsROM, r16		;  
 rcall	fl_Write_Sets

 mov	r16, akb_rMod			; /LAT = LAT,  qwerty
 sbr	r16, 1<<akb_Mod_RL
 cbr	r16, 1<<akb_Mod_Set
 mov	akb_rMod, r16
 rjmp	proc_SyncRL_ShowStatus

;
;   
proc_PlayMacro:
 rcall	proc_PressOnly
proc_PlayMacro1:
 sbrc	main_rFlagsRAM, main_FRAM_MRecord
 ret					;   ,    
 rcall	fl_Open_Macro			;   

proc_PM_loop:
 rcall	main_RunningLightsRight		;    

 rcall	fl_Read_Macro			;   
 breq	proc_PM_fin

 sbi	akb_RusLatPort, akb_RusLatPin	; /LAT
 sbrs	r16, 7
 cbi	akb_RusLatPort, akb_RusLatPin

 rcall	akb_SendByte_WithCtrl		;    
 rcall	Wait_CharPause
 rjmp	proc_PM_loop

proc_PM_fin:
 sbi	akb_RusLatPort, akb_RusLatPin	;   /LAT
 sbrs	akb_rMod, akb_Mod_RL
 cbi	akb_RusLatPort, akb_RusLatPin

 rjmp	pkb_ShowStatus			;  

;
;   
proc_CaptMacro:
 rcall	proc_PressOnly
 sbrc	main_rFlagsRAM, main_FRAM_MRecord
 rjmp	proc_CaptMacro_Stop		;    -  ţ

 ldi	r16, 1<<main_FRAM_MRecord	;  
 or	main_rFlagsRAM, r16
 rjmp	fl_Open_Macro			;   

proc_CaptMacro_Stop:
 ldi	r16, 0xFF-(1<<main_FRAM_MRecord)
 and	main_rFlagsRAM, r16		;  

 clr	r16				;     
 rcall	fl_Write_Macro
 
 rjmp	pkb_ShowStatus			;  

;
;   
;;    proc_FM_table,      :
;; -   (0/7/9,  ). 0xFF -  
;; -   .  ̣.
;; -   .  ̣.
;;        0x80:  10     HEX  :
;;   xxyy:xx xx xx xx xx xx xx xx
;;
proc_FixMacro7:
 ldi	r20, 7
 rjmp	proc_FixMacro
proc_FixMacro9:
 ldi	r20, 9

proc_FixMacro:
 rcall	proc_PressOnly
 sbrc	main_rFlagsRAM, main_FRAM_MRecord
 ret				;   ,    

 rcall	proc_FM_ClrScr		;     -    ӣ

 ldi	r23, 0x10		;   
 clr	r21
 rcall	proc_FM_draw

proc_FixMacro_loop:
 rcall	pkb_RecvCode_WithCtrl	;     
 rcall	table_Convert		;        ,    

 tst	akb_rLastChar		;   -   ,  ӣ   
 breq	proc_FixMacro_loop

 rcall	proc_FM_ClrScr

 mov	r21, akb_rLastChar	; ,   ģ -    -    
 ldi	r23, 0x20
 rcall	proc_FM_draw		;   

 sbi	akb_RusLatPort, akb_RusLatPin
 sbrs	akb_rMod, akb_Mod_RL	;   /LAT
 cbi	akb_RusLatPort, akb_RusLatPin

 clr	akb_rLastChar		;      
 clr	r24
 clr	r25
 ret

;
;    ӣ     
;       ӣ,  :
; r20    -  (7/9).  9     (  d3)
; r23.d4 -   +    
; r23.d5 -  
; r23.d0 -       (  )
; r21    -   (  'A')  0,  
proc_FM_draw:
 ldi	ZL, low (proc_FM_table*2)
 ldi	ZH, high(proc_FM_table*2)
 ldi	r22, 'A' | 0x80	;  ޣ    

proc_FM_draw_loop:
 lpm	r16, Z+
 cpi	r16, 0xFF
 breq	proc_FM_draw_ret

 andi	r23, 0xFE	;   

 tst	r21		;    
 breq	proc_FM_draw_loc0
 cp	r21, r22
 brne	proc_FM_draw_noprint
proc_FM_draw_loc0:

 tst	r16		;    
 breq	proc_FM_draw_loc1
 cp	r16, r20
 brne	proc_FM_draw_noprint

proc_FM_draw_loc1:
 ori	r23, 0x01	;  

proc_FM_draw_noprint:

;    

 ldi	r16, 27		;  ף-
 rcall	proc_FM_draw_print_23_4
 ldi	r16, 8
 rcall	proc_FM_draw_print_23_4
 ldi	r16, ' '
 rcall	proc_FM_draw_print_23_4

 mov	r16, r22	; - + 
 inc	r22
 rcall	proc_FM_draw_print_23_4
 ldi	r16, '.'
 rcall	proc_FM_draw_print_23_4

proc_FM_draw_header_loop:
 lpm	r16, Z+		; 
 tst	r16
 breq	proc_FM_draw_header_fin
 rcall	proc_FM_draw_print_23_4
 rjmp	proc_FM_draw_header_loop

proc_FM_draw_header_fin:
 ldi	r16, ' '
 rcall	proc_FM_draw_print_23_4
 ldi	r16, 'x' & 0x1F
 rcall	proc_FM_draw_print_23_4

;  

proc_FM_draw_body_loop:
 lpm	r16, Z+
 tst	r16
 breq	proc_FM_draw_loop
 cpi	r16, 0x80
 breq	proc_FM_draw_body_encode
 rcall	proc_FM_draw_print_23_5
 rjmp	proc_FM_draw_body_loop

;    

proc_FM_draw_body_encode:
 sbi	akb_RusLatPort, akb_RusLatPin	;       

 lpm	r16, Z+
 rcall	proc_FM_draw_printHEX_23_5
 lpm	r16, Z+
 rcall	proc_FM_draw_printHEX_23_5

 ldi	r16, ':'
 rcall	proc_FM_draw_print_23_5

 ldi	r19, 8
proc_FM_draw_body_encode_loop:
 lpm	r16, Z+
 rcall	proc_FM_draw_printHEX_23_5
 ldi	r16, ' '
 rcall	proc_FM_draw_print_23_5
 dec	r19
 brne	proc_FM_draw_body_encode_loop

 ldi	r16, 13
 rcall	proc_FM_draw_print_23_5
 rjmp	proc_FM_draw_body_loop

;
;   ,     rjmp...  
proc_FM_draw_ret:
 ret

;
;     d23.4 & d23.0 == 1
proc_FM_draw_print_23_4:
 mov	r17, r23
 andi	r17, 0x11
 cpi	r17, 0x11
 brne	proc_FM_draw_ret
 rcall	proc_FM_draw_9enc
 rcall	akb_SendByte_WithCtrl
 rjmp	Wait_CharPause

;
;     d23.5 & d23.0 == 1
proc_FM_draw_print_23_5:
 mov	r17, r23
 andi	r17, 0x21
 cpi	r17, 0x21
 brne	proc_FM_draw_ret
 rcall	proc_FM_draw_9enc
 rcall	akb_SendByte_WithCtrl
 rjmp	Wait_CharPause

proc_FM_draw_printHEX_23_5:
 mov	r17, r23
 andi	r17, 0x21
 cpi	r17, 0x21
 brne	proc_FM_draw_ret
 rjmp	akb_SendHEX

;
;   (  ӣ )
proc_FM_ClrScr:
 ldi	r16, 12
 rcall	akb_SendByte_WithCtrl
 rjmp	Wait_CharPause
 ldi	r16, '*'
 rcall	akb_SendByte_WithCtrl
 rjmp	Wait_CharPause

;
;     
;    /L  ,
;        ,    - .
;         
proc_FM_draw_9enc:
;     SM/RL	7654
; 00..3F nop		00xx
; 40..5F lat 60..7f/1	010x
; 60..7F  40..5f/0	011x
; 80..bf nop		10xx
; c0..df LAT 40..5f/1	110x
; e0..ff  60..7f/0	111x
 sbrs	r20, 3
 ret				;   ,   ͣ
 sbrs	r16, 6
 ret				;     -   

 sbi	akb_RusLatPort, akb_RusLatPin
 sbrc	r16, 5			;   /LAT   d5
 cbi	akb_RusLatPort, akb_RusLatPin

 ldi	r17, 1<<5
 sbrs	r16, 7			;       
 eor	r16, r17		;     d5
 ret
