;;=============================================================================
;;
;;     ,   AT  PS/2 -  
;;
;;==========================================================================
;; ,   
;;
;;   : reset, /lat  .
;;
;;   ,   .
;;
;;    ,   SPI:
;;     ,  8   ͣ   19   .
;;      = "1",     8 
;;      Clock.    ,     "0".
;;
;;            Clock,
;;       ,       
;; (100    ).
;;
;;       :
;; -  ͣ,    ,      
;;       Clock.
;; -  ,    ,        
;;  .         
;;   ģ   "0",   ɣ    
;;    ɣ  ģ   .  , , ,
;;   9 ,      "1",     
;;       Clock.
;;
;;    SPI          ,  
;;   (   "0"),    SPI.
;;

.equ	akb_ResetDDR	= DDRB
.equ	akb_ResetPort	= PORTB	;  (1 - )
.equ	akb_ResetPin	= 0

.equ	akb_RusLatDDR	= DDRD
.equ	akb_RusLatPort	= PORTD ; 1 - LAT, 0 - 
.equ	akb_RusLatPin	= 4

.equ	akb_DataDDR	= DDRB
.equ	akb_DataPort	= PORTB
.equ	akb_DataPin	= 4

.equ	akb_ClockPort	= PINB
.equ	akb_ClockPin	= 5


.dseg

.def	akb_rMod	= r0	;   

.equ	akb_Mod_RL	= 7	;  (0), LAT (1)
.equ	akb_Mod_IsPress	= 6	;       
.equ	akb_Mod_Win	= 5	; Win (flash-)
.equ	akb_Mod_Alt	= 4	; Alt ()
.equ	akb_Mod_Shift	= 3	; 
.equ	akb_Mod_Ctrl	= 2	; 
.equ	akb_Mod_IsHold	= 1	;      
.equ	akb_Mod_Set	= 0	; 
; IsHold  -         (  ,     )
; IsPress -      (..   IsHold   0)

.def	akb_rLastChar	= r1	;    (  ),    0,    

.cseg

;
; 
;    AT-    
;
akb_Init:
 clr	akb_rLastChar

 sbi	akb_ResetDDR, akb_ResetPin
 sbi	akb_RusLatDDR, akb_RusLatPin
 sbi	akb_DataDDR, akb_DataPin

 sbi	akb_DataPort, akb_DataPin

;   

 sbi	akb_ResetPort, akb_ResetPin

 ldi	r16, pkb_NumLed
 rcall	pkb_SetLed
 rcall	wait_300ms

 ldi	r16, pkb_NumLed | pkb_CapsLed
 rcall	pkb_SetLed
 rcall	wait_300ms

 ldi	r16, pkb_NumLed | pkb_CapsLed | pkb_ScroolLed
 rcall	pkb_SetLed
 rcall	wait_300ms

 cbi	akb_ResetPort, akb_ResetPin

; /LAT = LAT,  0

akb_ToLAT:
 ldi	r16, 1<<akb_Mod_RL
 mov	akb_rMod, r16
 sbi	akb_RusLatPort, akb_RusLatPin
 rjmp	pkb_ShowStatus

;
; ݣ  Init   PS/2-
;
akb_ShortInit:
 sbi	akb_RusLatDDR, akb_RusLatPin
 sbi	akb_RusLatPort, akb_RusLatPin

 sbi	akb_DataDDR, akb_DataPin
 sbi	akb_DataPort, akb_DataPin

;   

 sbi	akb_ResetDDR, akb_ResetPin
 sbi	akb_ResetPort, akb_ResetPin
 rcall	wait_300ms
 cbi	akb_ResetPort, akb_ResetPin

 ret


;
;     Clock
;    (> 4  == 250 )
;     C = 1      
;
akb_Wait0Clock:
 ldi	r28, 250
;
akb_W0C_loop:
 sbis	akb_ClockPort, akb_ClockPin	; 2
 ret
 dec	r28				; 1
 nop					; 1
 nop					; 1
 nop					; 1
 brne	akb_W0C_loop			; 2
 rjmp	akb_W1C_err
;
;
akb_Wait1Clock:
 ldi	r28, 250
;
akb_W1C_loop:
 sbic	akb_ClockPort, akb_ClockPin	; 2
 ret
 dec	r28				; 1
 nop					; 1
 nop					; 1
 nop					; 1
 brne	akb_W1C_loop			; 2
;
akb_W1C_err:
 pop	r28
 pop	r28
 sec
 ret

;
;        HEX-
;
akb_SendHEX:
 push	r16
; rcall	akb_ToLAT	;     ,     ,    ....
 rcall	Wait_CharPause	;        ,   ģ   ɣ 
 pop	r16

 push	r16
 lsr	r16
 lsr	r16
 lsr	r16
 lsr	r16
 rcall	akb_SendDig
 pop	r16
;
akb_SendDig:
 andi	r16, 0x0F
 cpi	r16, 10
 brlo	akb_SD_1
 subi   r16, -('A'-'0'-10)
akb_SD_1:
 subi   r16, -('0')

;
;    
;   C  : C = 0 - , C = 1 -    
;
akb_SendByte:
 andi	r16, 0x7F	;     = 0 ( -  ɣ )
 rcall	akb_Wait0Clock

 ldi	r18, 8		; ޣ 
akb_SB_loop0:
 rcall	akb_Wait1Clock

 cbi	akb_DataPort, akb_DataPin
 sbrc	r16, 7		;    (  ,    )
 sbi	akb_DataPort, akb_DataPin

 rcall	akb_Wait0Clock

 lsl	r16
 dec	r18
 brne	akb_SB_loop0

 rcall	Wait_4mks	;         "1"   ...
 sbi	akb_DataPort, akb_DataPin
 rcall	akb_Wait1Clock	; ..."1"       Clock = 1 -> 0

 clc
akb_SB_ret:
 ret

;
;         
;   ,  ,    ,  
;
akb_SendByte_WithCtrl:
 rcall	akb_SendByte
 brcc	akb_SB_ret
 ldi	r16, ec_akb_NoClock
 rjmp	Wait_MsgError

;
;    
; Ascii-   0x01,      
;     sizeof(PC) == 16 !!!
;
akb_Print:
 pop	ZH			; high
 pop	ZL			; low
 lsl	ZL
 rol	ZH

akb_P_2:
 lpm	r16, Z+
 cpi	r16, 1			;      EOL == 1,  
 breq	akb_P_1			;  .db "  " \\ .db " "
 rcall	akb_SendByte_WithCtrl	;        ,  
 rcall	Wait_CharPause		;   ASCIZ.
 rjmp	akb_P_2

akb_P_1:
 adiw	ZL, 1
 lsr	ZH
 ror	ZL
 ijmp

;
;    ", ^X"
;
akb_CR:
 rcall	akb_Print
.db ' ', 'x' & 0x1F, 27, 8, 32, 1
 ret
