;;=============================================================================
;;
;;     ,   AT  PS/2 -  
;;
;;==========================================================================
;;      (EEPROM).
;;       EEPROM  Sleep Mode.
;;
;;  ߣ EEPROM      :
;; -  (4) ,      ,    main_rFlagsROM
;; -  508    .
;;        ,        /LAT.
;;   -  00.
;;

;   X,    fl_Ptr       
.def	fl_PtrL		= r6
.def	fl_PtrH		= r7

.cseg

;
;   (main_rFlagsROM)
;
fl_Read_Sets:
 rcall	fl_WWait
 clr	r16
 out	EEARL, r16
 out	EEARH, r16
 sbi	EECR, EERE
 in	main_rFlagsROM, EEDR
 ret

;
;   (main_rFlagsROM)
;
fl_Write_Sets:
 rcall	fl_WWait
 clr	r16
 out	EEARL, r16
 out	EEARH, r16
 out	EEDR, main_rFlagsROM
; cli			;         ...
 sbi	EECR, EEMWE	; ...   
 sbi	EECR, EEWE
; sei
 ret

;
;     
;
fl_Open_Macro:
 ldi	r16, 4
 mov	fl_PtrL, r16
 clr	fl_PtrH
 ret
 
;
;   
;  Z = 1    
;
fl_Read_Macro:
 rcall	fl_PtrSet	;  

 sbi	EECR, EERE	; 
 in	r16, EEDR

 rcall	fl_PtrInc	;         

 tst	r16		;    
 ret

;
;   
;  Z = 1    
;
fl_Write_Macro:
 rcall	fl_PtrSet	;  

 out	EEDR, r16
; cli			;         ...
 sbi	EECR, EEMWE	; ...   
 sbi	EECR, EEWE
; sei

 rcall	fl_PtrInc	;         

 clz			;     -   ӣ ԣ
 ret

;
;       fl_Ptr  
;
fl_PtrSet:
 rcall	fl_WWait
 mov	XL, fl_PtrL
 mov	XH, fl_PtrH
 out	EEARL, XL
 out	EEARH, XH
 ret

;
;  fl_Ptr  1       
;    Z = 1       
;       
;
fl_PtrInc:
 adiw	X, 1
 cpi	XH, high(0x200)	; - ߣ     define 
 brne	fl_PI_loc0
 cpi	XL, low (0x200)
 brne	fl_PI_loc0
;
 pop	XL		;   
 pop	XH
 sez
 ret
;
fl_PI_loc0:
 mov	fl_PtrL, XL
 mov	fl_PtrH, XH
 ret

;
;   
;         sleep modes !
;
fl_WWait:
 sbic	EECR, EEWE
 rjmp	fl_WWait
 ret
