;;=============================================================================
;;
;;     ,   AT  PS/2 -  
;;
;;==========================================================================
;;    AT- (".dw",   0xE0,  )
;;     (".db"),     ,
;;     Ctrl  Shift
;;

;
;  PS/2   
;   r24/r25, 
; T = 0     ( akb_rLastChar),
; T = 1 -   ( akb_rLastChar)
;   akb_rLastChar, C = 0   
;     -> C = 1
;
table_Convert:
 ldi	ZL, low (table_p2a*2)
 ldi	ZH, high(table_p2a*2)

table_C_loop:
 lpm	XL, Z+			;   
 lpm	XH, Z+
 adiw	X, 0
 breq	table_C_fin
;
 cp	XL, r24			;    
 brne	table_C_next
 cp	XH, r25
 brne	table_C_next
;
 sbrc	akb_rMod, akb_Mod_Set	; 
 adiw	Z, 3

 sbrc	akb_rMod, akb_Mod_Ctrl	; Ctrl
 rjmp	table_C_ctrl		;    Shift  Ctrl ->  Ctrl

 sbrc	akb_rMod, akb_Mod_Shift	; Shift
 adiw	Z, 2
 rjmp	table_C_sel

table_C_ctrl:
 adiw	z, 1

table_C_sel:
 clc
 brts	table_C_release
 lpm	akb_rLastChar, Z	;   
 ret

table_C_release:
 clr	akb_rLastChar		;   ,    ,   Σ 
 ret

table_C_next:			;    
 adiw	Z, 6
 rjmp	table_C_loop
 
table_C_fin:			;  
 sec
 ret

; PS/2 - .dw:
;    .     ,    0xF0.
; ,     0xE0,  0xF0   0xE0.
;   "Pause"    ,      E1 14 77 E1  F0 14 F0 77

;  - .db:
;     :
; -  
; -   Ctrl
; -   Shift
;  :      ()

table_p2a:
.dw	0x6c	; +KP_Home
.db	0x90,0x90,0x90, 0x90,0x90,0x90
.dw	0x75	; +KP_Up
.db	0x91,0x91,0x91, 0x91,0x91,0x91
.dw	0x7d	; +KP_Prior
.db	0x92,0x92,0x92, 0x92,0x92,0x92
.dw	0x6b	; +KP_Left
.db	0x93,0x93,0x93, 0x93,0x93,0x93
.dw	0x73	; +KP_Begin
.db	0x94,0x94,0x94, 0x94,0x94,0x94
.dw	0x74	; +KP_Right
.db	0x9c,0x9c,0x9c, 0x9c,0x9c,0x9c
.dw	0x69	; +KP_End
.db	0x9d,0x9d,0x9d, 0x9d,0x9d,0x9d
.dw	0x72	; +KP_Down
.db	0x9e,0x9e,0x9e, 0x9e,0x9e,0x9e
.dw	0x7a	; +KP_Next
.db	0x9f,0x9f,0x9f, 0x9f,0x9f,0x9f
.dw	0x70	; +KP_Insert
.db	0x81,0x81,0x81, 0x81,0x81,0x81
.dw	0x71	; +KP_Delete
.db	0x82,0x82,0x82, 0x82,0x82,0x82
.dw	0xe05a	; +KP_Enter
.db	0x83,0x83,0x83, 0x83,0x83,0x83
.dw	0xe070	; +Insert
.db	0x81,0x81,0x81, 0x81,0x81,0x81
.dw	0xe06c	; +Home
.db	0x82,0x82,0x82, 0x82,0x82,0x82
.dw	0xe07d	; +Prior
.db	0x83,0x83,0x83, 0x83,0x83,0x83
.dw	0xe071	; +Delete
.db	0x84,0x84,0x84, 0x84,0x84,0x84
.dw	0xe069	; +End
.db	0x85,0x85,0x85, 0x85,0x85,0x85
.dw	0xe07a	; +Next
.db	0x86,0x86,0x86, 0x86,0x86,0x86

.dw	0xe075	; +Up
.db	0x99,0x99,0x99, 0x99,0x99,0x99
.dw	0xe072	; +Down
.db	0x9a,0x9a,0x9a, 0x9a,0x9a,0x9a
.dw	0xe06b	; +Left
.db	0x88,0x88,0x88, 0x88,0x88,0x88
.dw	0xe074	; +Right
.db	0x95,0x95,0x95, 0x95,0x95,0x95
.dw	0x66	; +BackSpace
.db	0x88,0x88,0x88, 0x88,0x88,0x88

.dw	0x76	; +Escape
.db	0x9b,0x9b,0x9b, 0x9b,0x9b,0x9b

.dw	0x5a	; +Return
.db	0x8d,0x8d,0x8d, 0x8d,0x8d,0x8d

.dw	0x29	; +space
.db	0xa0,0xa0,0xa0, 0xa0,0xa0,0xa0
.dw	0x0e	; +grave
.db	0xbb,0x00,0xab, 0xbb,0x00,0xab
.dw	0x16	; +1
.db	0xb1,0x00,0xa1, 0xb1,0x00,0xa1
.dw	0x1e	; +2
.db	0xb2,0x80,0xa2, 0xb2,0x80,0xa2
.dw	0x26	; +3
.db	0xb3,0x00,0xa3, 0xb3,0x00,0xa3
.dw	0x25	; +4
.db	0xb4,0x00,0xa4, 0xb4,0x00,0xa4
.dw	0x2e	; +5
.db	0xb5,0x00,0xa5, 0xb5,0x00,0xa5
.dw	0x36	; +6
.db	0xb6,0x9e,0xde, 0xb6,0x9e,0xde
.dw	0x3d	; +7
.db	0xb7,0x00,0xa6, 0xb7,0x00,0xa6
.dw	0x3e	; +8
.db	0xb8,0x00,0xaa, 0xb8,0x00,0xaa
.dw	0x46	; +9
.db	0xb9,0x00,0xa8, 0xb9,0x00,0xa8
.dw	0x45	; +0
.db	0xb0,0x00,0xa9, 0xb0,0x00,0xa9
.dw	0x4e	; +minus
.db	0xad,0x9f,0xdf, 0xad,0x9f,0xdf
.dw	0x55	; +equal
.db	0xbd,0x00,0xab, 0xbd,0x00,0xab
.dw	0x5d	; +backslash
.db	0xdc,0x9c,0xfc, 0xdc,0x9c,0xfc

.dw	0x1c	; +a
.db	0xc1,0x81,0xe1, 0xc6,0x81,0xe6
.dw	0x32	; +b
.db	0xc2,0x82,0xe2, 0xc9,0x82,0xe9
.dw	0x21	; +c
.db	0xc3,0x83,0xe3, 0xd3,0x83,0xf3
.dw	0x23	; +d
.db	0xc4,0x84,0xe4, 0xd7,0x84,0xf7
.dw	0x24	; +e
.db	0xc5,0x85,0xe5, 0xd5,0x85,0xf5
.dw	0x2b	; +f
.db	0xc6,0x86,0xe6, 0xc1,0x86,0xe1
.dw	0x34	; +g
.db	0xc7,0x87,0xe7, 0xd0,0x87,0xf0
.dw	0x33	; +h
.db	0xc8,0x88,0xe8, 0xd2,0x88,0xf2
.dw	0x43	; +i
.db	0xc9,0x89,0xe9, 0xdb,0x89,0xfb
.dw	0x3b	; +j
.db	0xca,0x8a,0xea, 0xcf,0x8a,0xef
.dw	0x42	; +k
.db	0xcb,0x8b,0xeb, 0xcc,0x8b,0xec
.dw	0x4b	; +l
.db	0xcc,0x8c,0xec, 0xc4,0x8c,0xe4
.dw	0x3a	; +m
.db	0xcd,0x8d,0xed, 0xd8,0x8d,0xf8
.dw	0x31	; +n
.db	0xce,0x8e,0xee, 0xd4,0x8e,0xf4
.dw	0x44	; +o
.db	0xcf,0x8f,0xef, 0xdd,0x8f,0xfd

.dw	0x4d	; +p
.db	0xd0,0x90,0xf0, 0xda,0x90,0xfa
.dw	0x15	; +q
.db	0xd1,0x91,0xf1, 0xca,0x91,0xea
.dw	0x2d	; +r
.db	0xd2,0x92,0xf2, 0xcb,0x92,0xeb
.dw	0x1b	; +s
.db	0xd3,0x93,0xf3, 0xd9,0x93,0xf9
.dw	0x2c	; +t
.db	0xd4,0x94,0xf4, 0xc5,0x94,0xe5
.dw	0x3c	; +u
.db	0xd5,0x95,0xf5, 0xc7,0x95,0xe7
.dw	0x2a	; +v
.db	0xd6,0x96,0xf6, 0xcd,0x96,0xed
.dw	0x1d	; +w
.db	0xd7,0x97,0xf7, 0xc3,0x97,0xe3
.dw	0x22	; +x
.db	0xd8,0x98,0xf8, 0xde,0x98,0xfe
.dw	0x35	; +y
.db	0xd9,0x99,0xf9, 0xce,0x99,0xee
.dw	0x1a	; +z
.db	0xda,0x9a,0xfa, 0xd1,0x9a,0xf1

.dw	0x54	; +bracketleft
.db	0xdb,0x9b,0xfb, 0xc8,0x9b,0xe8
.dw	0x5b	; +bracketright
.db	0xdd,0x9d,0xfd, 0xdf,0x9d,0xff

.dw	0x41	; +comma
.db	0xac,0x00,0xbc, 0xc2,0x00,0xe2
.dw	0x49	; +period
.db	0xae,0x00,0xbe, 0xc0,0x00,0xe0
.dw	0x4a	; +slash
.db	0xaf,0x00,0xbf, 0xaf,0x00,0xbf
.dw	0x4c	; +semicolon
.db	0xbb,0x00,0xba, 0xd6,0x00,0xf6
.dw	0x52	; +apostrophe
.db	0xa7,0x00,0xa2, 0xdc,0x00,0xfc

.dw	0

;
;    akb_rMod     .
;      r24/r25,  T = 0    , T = 1 -  .
;     ,   akb_rMod.akb_Mod_IsPress/IsHold ( "" )
;
table_ModProc:
 ldi	r16, 0xFF-(1<<akb_Mod_IsPress)
 and	akb_rMod, r16		; IsPress       ( IsHold = 0)

 ldi	ZL, low (table_Modifiers*2)
 ldi	ZH, high(table_Modifiers*2)

table_MP_loop:
 lpm	XL, Z+			;   
 lpm	XH, Z+
 adiw	X, 0
 breq	table_MP_Match
;
 cp	XL, r24			;    
 brne	table_MP_next
 cp	XH, r25
 brne	table_MP_next
;
table_MP_Match:
 lpm	r16, Z			;        (  )
 brts	table_MP_release

 sbrc	akb_rMod, akb_Mod_IsHold
 rjmp	table_MP_loc0
 sbrs	r16, akb_Mod_IsHold	; if (old_IsHold = 0) and (new_IsHold = 1) then IsPress = 1
 rjmp	table_MP_loc0
 sbr	r16, 1<<akb_Mod_IsPress

table_MP_loc0:
 or	akb_rMod, r16		;   
 ret

table_MP_release:		;   
 com	r16
 and	akb_rMod, r16
 ret

table_MP_next:			;    
 adiw	Z, 2
 rjmp	table_MP_loop


; .dw -   (PS/2)
; .db -  
;  ̣   ,    ӣ   
table_Modifiers:
.dw	0x0012
.db	1<<akb_Mod_Shift, 0
.dw	0x0059
.db	1<<akb_Mod_Shift, 0

.dw	0x000D
.db	1<<akb_Mod_Ctrl, 0
.dw	0x0014
.db	1<<akb_Mod_Ctrl, 0
.dw	0xE014
.db	1<<akb_Mod_Ctrl, 0

.dw	0x0011
.db	1<<akb_Mod_Alt, 0
.dw	0xE011
.db	1<<akb_Mod_Alt, 0

.dw	0xE01F
.db	1<<akb_Mod_Win, 0
.dw	0xE027
.db	1<<akb_Mod_Win, 0

.dw	0     		;   
.db	1<<akb_Mod_IsHold
