;;=============================================================================
;;
;;     ,   AT  PS/2 -  
;;
;;==========================================================================
;;  
;;

.nolist
.include "/usr/local/include/avr/m8def.inc"
.list

;  ,     
.equ	ec_pkb_NoInitAnswer	= 1
.equ	ec_pkb_FaultInitAnswer	= 2
.equ	ec_akb_NoClock		= 3
.equ	ac_pkb_UnableSendEcho	= 4
.equ	ac_pkb_UnableRecvEcho	= 5
.equ	ac_pkb_InvalidEcho	= 6
.equ	ac_pkb_InvMouseInit	= 7

;       
.equ	proc_FM_table		= 0x800

;      
.def	main_rFlagsRAM		= r4	;      
.def	main_rFlagsROM		= r5	;       EEPROM

.equ	main_FRAM_MRecord	= 1	; 1         
.equ	main_FRAM_MouseMode	= 0	; 1           ,    

.equ	main_FROM_RepMode	= 1	; 0 -   "", 1 -   "PC"
.equ	main_FROM_RL_sync	= 0	; 0 - /Lat    , 1 - 

; ޣ " "
.def	main_rRunningLight	= r3

;   
.def	main_rMouseKeys		= r8	; D2..D0 - ,  

.cseg

.org	0x000
 rjmp	RESET		; Reset Handler
 rjmp	EXT_INT0	; IRQ0 Handler
 rjmp	EXT_INT1	; IRQ1 Handler
 rjmp	TIM2_COMP	; Timer2 Compare Handler
 rjmp	TIM2_OVF	; Timer2 Overflow Handler
 rjmp	TIM1_CAPT	; Timer1 Capture Handler
 rjmp	TIM1_COMPA	; Timer1 CompareA Handler
 rjmp	TIM1_COMPB	; Timer1 CompareB Handler
 rjmp	TIM1_OVF	; Timer1 Overflow Handler
 rjmp	TIM0_OVF	; Timer0 Overflow Handler
 rjmp	SPI_STC		; SPI Transfer Complete Handler
 rjmp	USART_RXC	; USART RX Complete Handler
 rjmp	USART_UDRE	; UDR Empty Handler
 rjmp	USART_TXC	; USART TX Complete Handler
 rjmp	ADCR		; ADC Conversion Complete Handler
 rjmp	EE_RDY		; EEPROM Ready Handler
 rjmp	ANA_COMP	; Analog Comparator Handler
 rjmp	TWSI		; Two-wire Serial Interface
 rjmp	SPM_RDY		; Store Program Memory Ready

EXT_INT0:
EXT_INT1:
TIM2_COMP:
TIM2_OVF:
TIM1_CAPT:
TIM1_COMPA:
TIM1_COMPB:
TIM1_OVF:
TIM0_OVF:
SPI_STC:
USART_RXC:
USART_UDRE:
USART_TXC:
ADCR:
EE_RDY:
ANA_COMP:
TWSI:
SPM_RDY:


;;;;;;;;;;;;
;;    

RESET:

; Set Stack Pointer to top of RAM
 ldi	r16, high(RAMEND)
 out	SPH, r16
 ldi	r16, low(RAMEND)
 out	SPL, r16

;;;;;;;;;;;;
;      PullUp,    
 ldi	r16, 0xFF
 out	PORTB, r16
 out	PORTC, r16
 out	PORTD, r16

;;;;;;;;;;;;
;    

 clr	main_rRunningLight
 clr	main_rMouseKeys
 rcall	fl_Read_Sets	;    EEPROM (main_rFlagsROM)
 clr	main_rFlagsRAM	;     (main_rFlagsRAM)
 rcall	Wait_Init	;         
 rcall	Debug_Init	;        
 rcall	pkb_Init	;  PS/2- :    ţ    
 rcall	akb_Init	;      


;;;;;;;;;;;;
;   

MainLoop:

;======
;    : ,  PC,  

 sbrc	main_rFlagsRAM, main_FRAM_MouseMode
 rjmp	MainMouse
 sbrc	main_rFlagsROM, main_FROM_RepMode
 rjmp	MainKbd_PCRepeat


;======
;  :  
;
;     PS/2       (   ,
;    ) - 2   .    1/40  (25 ms).  
;  ,    Echo,      ( ).
;     40   ,       (Alt)  16 (Win)
;          .

MainKbd_AgRepeat:
 rcall	pkb_SetSlow

MainKbd_AgR_loc_1:
 rcall	main_RunningLightIfCaptMacro
 rcall	pkb_RecvCode_WithCtrl
 brcs	MainKbd_AgR_NoPress

 rcall	table_ModProc		;   -: Shift, Ctrl... -
 				;     /    akb_rMod
 rcall	proc_IntKeyRouter	;     
 				;    -
 rcall	table_Convert		;      PS/2-   

 tst	akb_rLastChar
 breq	MainKbd_AgR_loc_1	;   -  

 sbrc	akb_rMod, akb_Mod_Win	;   Win: 16  
 rjmp	MainKbd_AgR_loc_2	;    

 sbrs	akb_rMod, akb_Mod_IsPress
 rjmp	MainKbd_AgR_loc_1	;  -   (),  

MainKbd_AgR_loc_2:
 rcall	main_SendAndSend16	;   1  16     ģ,   
 rjmp	MainKbd_AgR_loc_1

;   ,   
MainKbd_AgR_NoPress:
 sbrs	akb_rMod, akb_Mod_Alt
 rjmp	MainLoop		;         -    

 tst	akb_rLastChar		;  ,   
 breq	MainKbd_AgR_loc_1

 rcall	main_SendAndSend16	;   1  16   
 rjmp	MainKbd_AgR_loc_1


;======
;  :  PC
;
;     PS/2       - 30   .
;      :  ,     (Alt) -      .
; 16 (Win) .

MainKbd_PCRepeat:
 rcall	pkb_SetFast

MainKbd_PCR_loc_1:
 rcall	main_RunningLightIfCaptMacro
 rcall	pkb_RecvCode_WithCtrl
 brcs	MainLoop		;    ,    ӣ

 rcall	table_ModProc		;   -: Shift, Ctrl... -
 				;     /    akb_rMod
 rcall	proc_IntKeyRouter	;     
 				;    -
 rcall	table_Convert		;      PS/2-   

 tst	akb_rLastChar
 breq	MainKbd_PCR_loc_1	;   -  

 rcall	main_SendAndSend16	;       :  ""   1  16 

 rjmp	MainKbd_PCR_loc_1


;======
;  : 
;
;    , :
; ,  -  
; ,  -  
; ,  -  
; ,  -  
; ,  -  

MainMouse:
 rcall	pkb_RecvCode		;  .      
 brcs	MainMouse
 mov	r20, r16

 cpi	r16, 0xAA		;  , ,     ,   
 breq	MainMouseRescan		; ,       

 rcall	pkb_RecvCode		;   X
 brcs	MainMouse		;     -   - , ģ  
 sbrc	r20, 4			;      
 neg	r16
 mov	r21, r16
 
 rcall	pkb_RecvCode		;   Y
 brcs	MainMouse
 sbrc	r20, 5
 neg	r16
 mov	r22, r16

;   
;    

 mov	r16, r20
 andi	r16, 0x07
 mov	r17, r16
 eor	r16, main_rMouseKeys	;   r16 ,  
 mov	main_rMouseKeys, r17	;    

 sbrc	r16, 0			;    
 rjmp	MainMouse_SSpace

 sbrs	r16, 1			;    
 rjmp	MainMouse_loc0
 sbrc	main_rMouseKeys, 1	; ޣ ţ  (  )
 rjmp	MainMouse_SSpace
 
MainMouse_loc0:
 sbrs	r16, 2			;    
 rjmp	MainMouse_Move
 sbrc	main_rMouseKeys, 2	; ޣ ţ  (  )
 rcall	proc_PlayMacro1

;   
MainMouse_Move:

MainMouse_MoveX:
 tst	r21
 breq	MainMouse_MoveY
 ldi	r16, 0x08
 sbrs	r20, 4
 ldi	r16, 0x15
 rcall	akb_SendByte_WithCtrl
 rcall	Wait_CharPause
 dec	r21
 rjmp	MainMouse_MoveX
 
MainMouse_MoveY:
 tst	r22
 breq	MainMouse
 ldi	r16, 0x99
 sbrc	r20, 5
 ldi	r16, 0x9A
 rcall	akb_SendByte_WithCtrl
 rcall	Wait_CharPause
 dec	r22
 rjmp	MainMouse_MoveY

;  
MainMouse_SSpace:
 ldi	r16, ' '
 rcall	akb_SendByte_WithCtrl
 rjmp	MainMouse_Move

; ,  ģ
MainMouseRescan:
 rcall	pkb_Init
 rcall	pkb_ShowStatus
 rjmp	MainLoop
 

;;;;;;;;;;;;
;  ,     ,      ,  ţ 
;  ,    ,       

;
;         16  (   Win-key)
;      -    -
;
main_SendAndSend16:
 mov	r16, akb_rLastChar
 sbrs	akb_rMod, akb_Mod_Win	;  16   -   
 rjmp	main_SS16_SendAndWrite

 ldi	r20, 16			;   ޣ  16  ̣ ,    
main_SS16_loop:
 mov	r16, akb_rLastChar
 rcall	main_SS16_SendAndWrite
 rcall	Wait_CharPause
 dec	r20
 brne	main_SS16_loop
 ret
;
;        ,     
main_SS16_SendAndWrite:
 sbrs	main_rFlagsRAM, main_FRAM_MRecord
main_SS16_Send:
 rjmp	akb_SendByte_WithCtrl	;     -    

 sbrs	akb_rMod, akb_Mod_RL	;       
 andi	r16, 0x7F
 rcall	fl_Write_Macro		; 
 brne	main_SS16_Send		;     
;
;    ,    (     ģ,   )
 ldi	r16, 0xFF-(1<<main_FRAM_MRecord)
 and	main_rFlagsRAM, r16	;  

 rjmp	pkb_ShowStatus		;  


;
;   ,  ģ  
;
main_RunningLightIfCaptMacro:
 sbrs	main_rFlagsRAM, main_FRAM_MRecord
 ret


;
;    .     ݣ
;   4  ()   : 000 100 110 111 011 001 (   )
;
main_RunningLightsLeft:
 ldi	ZL, low (main_RLL*2)
 ldi	ZH, high(main_RLL*2)
 rjmp	main_RL_start

main_RunningLightsRight:
 ldi	ZL, low (main_RLR*2)
 ldi	ZH, high(main_RLR*2)
;
main_RL_start:
 mov	r16, main_rRunningLight
 cpi	r16, 6*4			; 4    * 6 
 brne	main_RL_loc0
 clr	main_rRunningLight		; r16   ,       ( ף)
main_RL_loc0:

 andi	r16, 0x03			;  3  4 
 brne	main_RL_fin

 mov	r17, main_rRunningLight		;  r17    
 lsr	r17
 lsr	r17
 clr	r16
 add	ZL, r17				;        
 adc	ZH, r16

 lpm	r16, Z				;     
 rcall	pkb_SetLed			;   ţ

main_RL_fin:
 inc	main_rRunningLight
 ret

main_RLL: ;     ݣ (d2 <-> d1): 
.db	0b000, 0b010, 0b110, 0b111, 0b101, 0b001
main_RLR: ;  pkb_*Led      
.db	0b000, 0b001, 0b101, 0b111, 0b110, 0b010


;;;;;;;;;;;;
;      

.include	"ps2agatKBD-1-debug.inc"
.include	"ps2agatKBD-2-processor.inc"
.include	"ps2agatKBD-4-akb.inc"
.include	"ps2agatKBD-5-wait_led.inc"
.include	"ps2agatKBD-6-pkb.inc"
.include	"ps2agatKBD-7-flash.inc"
.include	"ps2agatKBD-8-tables.inc"
